地址:http://acm.hdu.edu.cn/showproblem.php?pid=1025
Constructing Roads In JGShining's Kingdom
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 13726 Accepted Submission(s): 3908
Problem Description
JGShining's kingdom consists of 2n(n is no more than 500,000) small cities which are located in two parallel lines.
Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we call them poor cities). Each poor city is short of exactly one kind of resource and also each rich city is rich in exactly one kind of resource. You may assume no two poor cities are short of one same kind of resource and no two rich cities are rich in one same kind of resource.
With the development of industry, poor cities wanna import resource from rich ones. The roads existed are so small that they're unable to ensure the heavy trucks, so new roads should be built. The poor cities strongly BS each other, so are the rich ones. Poor cities don't wanna build a road with other poor ones, and rich ones also can't abide sharing an end of road with other rich ones. Because of economic benefit, any rich city will be willing to export resource to any poor one.
Rich citis marked from 1 to n are located in Line I and poor ones marked from 1 to n are located in Line II.
The location of Rich City 1 is on the left of all other cities, Rich City 2 is on the left of all other cities excluding Rich City 1, Rich City 3 is on the right of Rich City 1 and Rich City 2 but on the left of all other cities ... And so as the poor ones.
But as you know, two crossed roads may cause a lot of traffic accident so JGShining has established a law to forbid constructing crossed roads.
For example, the roads in Figure I are forbidden.
In order to build as many roads as possible, the young and handsome king of the kingdom - JGShining needs your help, please help him. ^_^
Half of these cities are rich in resource (we call them rich cities) while the others are short of resource (we call them poor cities). Each poor city is short of exactly one kind of resource and also each rich city is rich in exactly one kind of resource. You may assume no two poor cities are short of one same kind of resource and no two rich cities are rich in one same kind of resource.
With the development of industry, poor cities wanna import resource from rich ones. The roads existed are so small that they're unable to ensure the heavy trucks, so new roads should be built. The poor cities strongly BS each other, so are the rich ones. Poor cities don't wanna build a road with other poor ones, and rich ones also can't abide sharing an end of road with other rich ones. Because of economic benefit, any rich city will be willing to export resource to any poor one.
Rich citis marked from 1 to n are located in Line I and poor ones marked from 1 to n are located in Line II.
The location of Rich City 1 is on the left of all other cities, Rich City 2 is on the left of all other cities excluding Rich City 1, Rich City 3 is on the right of Rich City 1 and Rich City 2 but on the left of all other cities ... And so as the poor ones.
But as you know, two crossed roads may cause a lot of traffic accident so JGShining has established a law to forbid constructing crossed roads.
For example, the roads in Figure I are forbidden.

In order to build as many roads as possible, the young and handsome king of the kingdom - JGShining needs your help, please help him. ^_^
Input
Each test case will begin with a line containing an integer n(1 ≤ n ≤ 500,000). Then n lines follow. Each line contains two integers p and r which represents that Poor City p needs to import resources from Rich City r. Process to the end of file.
Output
For each test case, output the result in the form of sample.
You should tell JGShining what's the maximal number of road(s) can be built.
You should tell JGShining what's the maximal number of road(s) can be built.
Sample Input
2 1 2 2 1 3 1 2 2 3 3 1
Sample Output
Case 1: My king, at most 1 road can be built. Case 2: My king, at most 2 roads can be built.HintHuge input, scanf is recommended.
1个富裕城市只能向1个贫困城市输出资源,1个贫困城市只能向1个富裕城市索求资源
现在要修贫困城市与富裕城市之间的道路,并且道路不能相交,问最多能修几条。
思路:LIS,再利用二分寻找位置就可以了。
LIS:最长上升子序列,做法就是在相同情况的位置保持最小的数字,不断更新。
例如:2,1,5,4,6,3这一列数
第一:2
第二:1 (这里用1把2替换掉,因为这两个数字情况相同,且1比2小)
第三:1,5
第四:1,4 (原理同上)
第五:1,4,6
第六:1,3,6
最终结果就是1,4,6,但这里得出的数列是1,3,6。如果只是求长度就无所谓,但若是求序列就需要注意这种情况。
代码:
#include<cmath>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
using namespace std;
struct node{
int p,r;
}city[500010];
int ans[500010],len;
bool kmp(node a,node b)
{
return a.p<b.p;
}
int erf(int a,int b,int k) //二分
{
while(a<=b)
{
int mid=(a+b)/2;
if(ans[mid]>k) b=mid-1;
else a=mid+1;
}
return a;
}
int main()
{
int n,cas=1;
while(scanf("%d",&n)>0)
{
memset(ans,0,sizeof(ans));len=0;
for(int i=0;i<n;i++)
scanf("%d%d",&city[i].p,&city[i].r);
sort(city,city+n,kmp);
for(int i=0;i<n;i++)
{
int k=erf(0,len,city[i].r);
ans[k]=city[i].r;
if(k>len) len=k;
}
if(len==1) printf("Case %d:\nMy king, at most 1 road can be built.\n\n",cas++); //注意有两个换行
else printf("Case %d:\nMy king, at most %d roads can be built.\n\n",cas++,len);
}
return 0;
}